package com.zd.exam.mapper;

import com.zd.exam.domain.ElPaperQu;
import com.zd.exam.domain.ElPaperQuAnswer;

import java.util.List;
import java.util.Map;

/**
 * 试卷考题Mapper接口
 *
 * @author zd
 * @date 2021-08-31
 */
public interface ElPaperQuMapper {
    /**
     * 查询试卷考题
     *
     * @param id 试卷考题主键
     * @return 试卷考题
     */
    public ElPaperQu selectElPaperQuById(Long id);

    /**
     * 查询试卷考题
     *
     * @param paperId 试卷id
     * @return 试卷考题 和明细
     */
    public List<ElPaperQu> selectElPaperQuByPaperId(Long paperId);

    /**
     * 查询试卷考题列表
     *
     * @param elPaperQu 试卷考题
     * @return 试卷考题集合
     */
    public List<ElPaperQu> selectElPaperQuList(ElPaperQu elPaperQu);

    /**
     * 新增试卷考题
     *
     * @param elPaperQu 试卷考题
     * @return 结果
     */
    public int insertElPaperQu(ElPaperQu elPaperQu);

    /**
     * 修改试卷考题
     *
     * @param elPaperQu 试卷考题
     * @return 结果
     */
    public int updateElPaperQu(ElPaperQu elPaperQu);

    /**
     * 删除试卷考题
     *
     * @param id 试卷考题主键
     * @return 结果
     */
    public int deleteElPaperQuById(Long id);

    /**
     * 批量删除试卷考题
     *
     * @param ids 需要删除的数据主键集合
     * @return 结果
     */
    public int deleteElPaperQuByIds(Long[] ids);

    /**
     * 批量新增试卷考题备选答案
     *
     * @param elPaperQuAnswerList 试卷考题备选答案列表
     * @return 结果
     */
    public int batchElPaperQuAnswer(List<ElPaperQuAnswer> elPaperQuAnswerList);


    /**
     * 通过试卷考题主键删除试卷考题备选答案信息
     *
     * @param id 试卷考题ID
     * @return 结果
     */
    public int deleteElPaperQuAnswerByQuId(Long id);

    int deleteElPaperQuAnswerByQuIds(Long[] ids);

    int sumObjective(Long paperId);

    ElPaperQu selectOneByPaperQuId(ElPaperQu paperQu);

    List<Map<String, Object>> queryPaperStatisticsByPaperId(Long paperId);

    Map<String, Object> selectCountByPaperId(Long paperId);
}
